package com.smoa.comp.sdk;

import java.util.List;

import javax.xml.bind.JAXBException;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebServiceFeature;
import javax.xml.ws.handler.Handler;

import com.smoa.comp.stubs.socks.NotAuthorizedFault;
import com.smoa.comp.stubs.socks.SMOAComputingSocks;
import com.smoa.comp.stubs.socks.SMOAComputingSocksPortType;
import com.smoa.core.sdk.SMOACoreService;
import com.smoa.core.sdk.security.AuthenticationModule;

public class SMOASocks extends SMOACoreService {

    protected SMOAComputingSocksPortType port; 
    
    public SMOASocks(String hostname, int port,
	    AuthenticationModule transportLayer,
	    AuthenticationModule messageLayer, boolean useWSA)
	    throws JAXBException {
	super(hostname, port, transportLayer, messageLayer, useWSA);
	this.port = (SMOAComputingSocksPortType) stubs;
    }

    public SMOASocks(String hostname, int port,
	    AuthenticationModule transportLayer,
	    AuthenticationModule messageLayer) throws JAXBException {
	super(hostname, port, transportLayer, messageLayer);
	this.port = (SMOAComputingSocksPortType) stubs;
    }

    public SMOASocks(String hostname, int port, AuthenticationModule am)
	    throws JAXBException {
	super(hostname, port, am);
	this.port = (SMOAComputingSocksPortType) stubs;
    }

    public static final String SMOA_SOCKS_NS = "http://schemas.smoa-project.com/comp/2010/08/socks";

    @Override
    protected List<Handler> getHandlersChain() {
	return null;
    }

    @Override
    protected Object getPort(Service service, WebServiceFeature... features) {
	return ((SMOAComputingSocks) service).getSMOAComputingSocks(features);
    }

    @Override
    protected Service getService() {
	return new SMOAComputingSocks(
		SMOASocks.class.getResource("/schemas/smoa-comp-socks.wsdl"),
		new QName(SMOA_SOCKS_NS, "SMOAComputingSocks"));
    }
    
    public String getToken() throws NotAuthorizedFault {
	return port.getConnectionToken(null).getSecurityToken();
    }
    
}