package com.smoa.comp.sdk.exceptions;

import com.smoa.comp.sdk.exceptions.SMOACompException;
import com.smoa.comp.sdk.types.SMOAActivityStatus;

public class CantApplyOperationToCurrentStateException extends SMOACompException {
	protected SMOAActivityStatus status;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public CantApplyOperationToCurrentStateException(Throwable ex) {
		super(ex.getMessage(), ex);
		
		if (ex instanceof com.smoa.comp.stubs.bes.factory.CantApplyOperationToCurrentStateFault) {
			com.smoa.comp.stubs.bes.factory.CantApplyOperationToCurrentStateFault f = (com.smoa.comp.stubs.bes.factory.CantApplyOperationToCurrentStateFault)ex;
			status = new SMOAActivityStatus(null, f.getFaultInfo().getActivityStatus());
			infoMessage = f.getFaultInfo().getMessage() + " (current state = " + status.toString() + ")";
		} else {
			throw new AssertionError(ex);
		}
	}
	
	public SMOAActivityStatus getCurrentStatus(){
		return status;
	}
}
