package com.smoa.comp.sdk.exceptions;

import java.util.List;

public class SMOACompException extends Exception {

	private static final long serialVersionUID = 1L;
	protected String infoMessage;

	public SMOACompException() {
		super();
	}

	public SMOACompException(String arg0, Throwable arg1) {
		super(arg0, arg1);
	}

	public SMOACompException(String arg0) {
		super(arg0);
	}

	public SMOACompException(Throwable arg0) {
		super(arg0);
	}

	@Override
	public String toString() {
		if (infoMessage != null)
			return getMessage() + " : " + infoMessage;
		else
			return infoMessage;
	}
	
	protected void setInfoMessage(List<String> list){
		if (list.size()!=0) {
			StringBuffer sb = new StringBuffer(128 * list.size());

			for (String el: list) {
				if (sb.length() != 0)
					sb.append(',');
				
				sb.append(el);
			}
			
			infoMessage = sb.toString();
		}
	}
	
	public String getInfoMessage() {
		return infoMessage;
	}
}
