package com.smoa.comp.tests;



import java.util.Date;

import com.smoa.comp.sdk.ardl.ARDL;
import com.smoa.comp.sdk.jsdl.JSDL;
import com.smoa.comp.sdk.types.ActivityEndpointReference;
import com.smoa.comp.sdk.types.SMOAActivityStatus;

/**
 * Unit test for simple App.
 */
public class AROneCpuTest extends SMOACompConfig
{
	

	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	
	public void testReservationOneCpu() throws Exception {
		
		try {
		ARDL ardl = new ARDL(120);
		ardl.setUserName(username1);
		
		resEpr1 = ares.createReservation(ardl);
		
		System.err.println("Reservation created: " + resEpr1);
		
		//ares.terminateReservation(repr);
		//System.err.println("Reservation terminated.");
		
		JSDL jsdl = new JSDL("sleep");
		jsdl.setExecutable("/bin/sleep");
		jsdl.getArguments().add("20");
		jsdl.setReservationIdentifier(resEpr1);
		jsdl.setUserName(username1);
		
		jobEpr1 = factory.createActivity(jsdl);
		
		System.err.println("Job submitted = " + new Date());
		
		System.err.println("jobEpr = " + jobEpr1);
		
		waitForState(jobEpr1, SMOAActivityStatus.SMOA_ACTIVITY_STATE_EXECUTING);
		
		System.err.println("Job started = " + new Date());
		
		jobEpr1 = new ActivityEndpointReference(jobEpr1.getAddress(), jobEpr1.getActivityUUID());
		
		waitForTermination(jobEpr1);
		
		System.err.println("Job finished with stat " +  factory.getActivityStatus(jobEpr1) + " = " + new Date());
		} catch (Exception ex) {
			ex.printStackTrace();
			fail();
		} finally {
			ares.terminateReservation(resEpr1);
		}
	}
	
}
