package com.smoa.comp.tests;



import com.smoa.comp.sdk.jsdl.JSDL;
import com.smoa.comp.sdk.jsdl.JSDLDataStaging;
import com.smoa.comp.sdk.types.ActivityEndpointReference;
import com.smoa.comp.sdk.types.SMOAActivityStatus;

/**
 * Unit test for simple App.
 */
public class CurlStagingTest 
    extends SMOACompConfig
{
	

	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}
	
	public void testCurlStaging() throws Throwable {
		
		JSDL jsdl = new JSDL("date");
		jsdl.setExecutable("/bin/date");
		jsdl.getDataStaging().add(new JSDLDataStaging("inout", "http://hedera.man.poznan.pl/", null));
		jsdl.getDataStaging().add(new JSDLDataStaging("inout", null, "file:///tmp/services"));
		
		ActivityEndpointReference jobEpr = factory.createActivity(jsdl);
		
		System.err.println("jobEpr = " + jobEpr);
		
		
		SMOAActivityStatus stat = null;
		while (!(stat = factory.getActivityStatus(jobEpr)).isFinalState()) {
			System.err.println(stat);
			Thread.sleep(5000);
		}
		
		jobEpr = new ActivityEndpointReference(jobEpr.getAddress(), jobEpr.getActivityUUID());
		
		System.err.println("final stat: " + stat);

		System.err.println("Job is done!");
	}
	
}
