package com.smoa.comp.tests;



import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.smoa.comp.sdk.ardl.ARDL;
import com.smoa.comp.sdk.exceptions.NotAuthorizedException;
import com.smoa.comp.sdk.exceptions.UnknownReservationIdentifierException;
import com.smoa.comp.sdk.types.ReservationEndpointReference;
/**
 * Unit test for simple App.
 */
public class QCGResManagerTest extends SMOACompConfig
{
	
	@Override
	protected void setUp() throws Exception {
		super.setUp();
		
	}

	
	static SimpleDateFormat dateformat = new SimpleDateFormat("yyyy:MM:dd HH:mm");
	
	public void testQCG() throws ParseException {
		
		//by default use INRIA to change this see FedCompTest.java
		ReservationEndpointReference rAll1 = null;
		ReservationEndpointReference rAll2 = null;
		
	try {
		
		Date time1 = dateformat.parse("2009:03:01 8:00");
		Date time2 = dateformat.parse("2009:03:01 11:00");
		Date time3 = dateformat.parse("2009:03:01 13:00");
		Date time4 = dateformat.parse("2009:03:01 16:00");

		ARDL ardl = new ARDL(time2, time3); 
		
		ardl.setUserName(username1); 
		ardl.setName("12345");
		ardl.setTotalSlotsCount(1);
		ardl.setAdditionalSlotsCount(1);
		ardl.setStrictWindow(true);
		
		resEpr1 = ares.createReservation(ardl);
		
		assertEquals(time2, ares.getReservationDocument(resEpr1).getArdl().getStartTime());
		assertEquals(time3, ares.getReservationDocument(resEpr1).getArdl().getEndTime());
		
		ardl = new ARDL(time1, time4); 
		
		ardl.setUserName(username1); 
		ardl.setName("12345");
		ardl.setTotalSlotsCount(1);
		ardl.setAdditionalSlotsCount(1);
		ardl.setStrictWindow(false);
		
		rAll1 = ares.createReservation(ardl);
		
		assertEquals(time1, ares.getReservationDocument(rAll1).getArdl().getStartTime());
		assertEquals(time2, ares.getReservationDocument(rAll1).getArdl().getEndTime());
		
		/* use the same ardl to get second "slice" */
		rAll2 = ares.createReservation(ardl);
		
		assertEquals(time3, ares.getReservationDocument(rAll2).getArdl().getStartTime());
		assertEquals(time4, ares.getReservationDocument(rAll2).getArdl().getEndTime());
		
		Thread.sleep(20000);
		try {
			//we must communicate to RTIS that something we are finishing global reservation phase
			ares.createReservation(ardl);
			fail();
		} catch (Exception ex) {
			
		}
		
		ares.terminateReservation(rAll1);
		ares.terminateReservation(rAll2);
		ares.terminateReservation(resEpr1);
		
	} catch (Throwable ex) {
			ex.printStackTrace();
			
			if (rAll1 != null) {
				try {
					ares.terminateReservation(rAll1);
				} catch (NotAuthorizedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnknownReservationIdentifierException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			if (rAll2 != null) {
				try {
					ares.terminateReservation(rAll2);
				} catch (NotAuthorizedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnknownReservationIdentifierException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			if (resEpr1 != null) {
				try {
					ares.terminateReservation(resEpr1);
				} catch (NotAuthorizedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnknownReservationIdentifierException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			

			
			fail();
		}
		
	}
	
	
}
