package com.smoa.comp.tests;



import com.smoa.comp.sdk.jsdl.JSDL;
import com.smoa.comp.sdk.types.ActivityEndpointReference;
import com.smoa.comp.sdk.types.SMOAActivityStatus;

/**
 * Unit test for simple App.
 */
public class SimpleSubmitTest 
    extends SMOACompConfig
{
	

	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	
	public void testSleepSubmit() throws Throwable {
		
		JSDL jsdl = new JSDL("sleep");
		jsdl.setExecutable("/bin/sleep");
		jsdl.setUserName(username1);
		jsdl.getArguments().add("20");
		
		jobEpr1 = factory.createActivity(jsdl);
		
		System.err.println("jobEpr = " + jobEpr1);
		System.err.println("job document = " + factory.getActivityDocuments(jobEpr1).getJsdl());
		System.err.println("local job id = " + factory.getActivityDocuments(jobEpr1).getLocalActivityId());
		
		waitForTermination(jobEpr1);
		
		//try to create job EPR form scratch
		jobEpr1 = new ActivityEndpointReference(jobEpr1.getAddress(), jobEpr1.getActivityUUID());
		
		System.err.println("final stat: " + factory.getActivityStatus(jobEpr1));
		assertEquals(SMOAActivityStatus.SMOA_ACTIVITY_STATE_FINISHED, factory.getActivityStatus(jobEpr1).getState());
		assertEquals(0, factory.getActivityStatus(jobEpr1).getEndStatus().getExitStatus().intValue());
	}
	
}
