package com.smoa.comp.tests.authentication;

import java.io.IOException;
import java.security.GeneralSecurityException;

import javax.xml.bind.JAXBException;

import junit.framework.TestCase;

import com.smoa.comp.sdk.SMOAFactory;
import com.smoa.comp.sdk.exceptions.CantApplyOperationToCurrentStateException;
import com.smoa.comp.sdk.exceptions.InvalidRequestMessageException;
import com.smoa.comp.sdk.exceptions.NotAuthorizedException;
import com.smoa.comp.sdk.exceptions.UnknownActivityIdentifierException;
import com.smoa.comp.sdk.exceptions.UnsupportedFeatureException;
import com.smoa.comp.sdk.jsdl.JSDL;
import com.smoa.comp.sdk.types.ActivityEndpointReference;
import com.smoa.core.sdk.security.ssl.SSLAuthentication;
import com.smoa.core.sdk.security.wsse.WSSEAuthentication;
import com.smoa.core.sdk.security.wsse.username.UsernameToken;

public class UserNameAuthenticationTest extends TestCase {
	
	static final String SMOA_COMP_HOST = "grass1.man.poznan.pl";
	
	static final int SMOA_COMP_PORT = 19001;
	static final String SMOA_COMP_DN = "/C=PL/O=GRID/O=PSNC/CN=host/grass1.man.poznan.pl";
	static final String USERNAME = "mmamonski";
	static final String PASSWORD = "kafGedEv]";
	
	public void testUserNameSSL() throws InvalidRequestMessageException, NotAuthorizedException, UnsupportedFeatureException, JAXBException, CantApplyOperationToCurrentStateException, UnknownActivityIdentifierException, IOException, GeneralSecurityException {

		
		SMOAFactory executionFactory = new SMOAFactory(SMOA_COMP_HOST, SMOA_COMP_PORT, new SSLAuthentication("/etc/grid-security/certificates/8a661490.0", null, SMOA_COMP_DN), new WSSEAuthentication(new UsernameToken(USERNAME, PASSWORD, false, false)));

		JSDL jsdl = new JSDL("DateExample");
		jsdl.setExecutable("/bin/date");
		
		ActivityEndpointReference jobEpr = executionFactory.createActivity(jsdl);
		
		System.err.println("Submitted activity: " + jobEpr);
		
		assertEquals(USERNAME, executionFactory.getActivityDocuments(jobEpr).getJsdl().getUserName());
		
		executionFactory.terminateActivity(jobEpr);
	}
	

}
